Commit 782f46cb authored by Naveen N Rao's avatar Naveen N Rao Committed by Michael Ellerman
Browse files

powerpc/ftrace: Add a postlink script to validate function tracer



Function tracer on powerpc can only work with vmlinux having a .text
size of up to ~64MB due to powerpc branch instruction having a limited
relative branch range of 32MB. Today, this is only detected on kernel
boot when ftrace is init'ed. Add a post-link script to check the size of
.text so that we can detect this at build time, and break the build if
necessary.

We add a dependency on !COMPILE_TEST for CONFIG_HAVE_FUNCTION_TRACER so
that allyesconfig and other test builds can continue to work without
enabling ftrace.

Signed-off-by: default avatarNaveen N Rao <naveen@kernel.org>
Signed-off-by: default avatarHari Bathini <hbathini@linux.ibm.com>
Signed-off-by: default avatarMichael Ellerman <mpe@ellerman.id.au>
Link: https://patch.msgid.link/20241030070850.1361304-11-hbathini@linux.ibm.com
parent 9670f6d2
Loading
Loading
Loading
Loading
+1 −1
Original line number Diff line number Diff line
@@ -243,7 +243,7 @@ config PPC
	select HAVE_FUNCTION_DESCRIPTORS	if PPC64_ELF_ABI_V1
	select HAVE_FUNCTION_ERROR_INJECTION
	select HAVE_FUNCTION_GRAPH_TRACER
	select HAVE_FUNCTION_TRACER		if PPC64 || (PPC32 && CC_IS_GCC)
	select HAVE_FUNCTION_TRACER		if !COMPILE_TEST && (PPC64 || (PPC32 && CC_IS_GCC))
	select HAVE_GCC_PLUGINS			if GCC_VERSION >= 50200   # plugin support on gcc <= 5.1 is buggy on PPC
	select HAVE_GENERIC_VDSO
	select HAVE_HARDLOCKUP_DETECTOR_ARCH	if PPC_BOOK3S_64 && SMP
+8 −0
Original line number Diff line number Diff line
@@ -24,6 +24,9 @@ else
	$(CONFIG_SHELL) $(srctree)/arch/powerpc/tools/relocs_check.sh "$(OBJDUMP)" "$(NM)" "$@"
endif

quiet_cmd_ftrace_check = CHKFTRC $@
      cmd_ftrace_check = $(CONFIG_SHELL) $(srctree)/arch/powerpc/tools/ftrace_check.sh "$(NM)" "$@"

# `@true` prevents complaint when there is nothing to be done

vmlinux: FORCE
@@ -34,6 +37,11 @@ endif
ifdef CONFIG_RELOCATABLE
	$(call if_changed,relocs_check)
endif
ifdef CONFIG_FUNCTION_TRACER
ifndef CONFIG_PPC64_ELF_ABI_V1
	$(call cmd,ftrace_check)
endif
endif

clean:
	rm -f .tmp_symbols.txt
+50 −0
Original line number Diff line number Diff line
#!/bin/bash
# SPDX-License-Identifier: GPL-2.0-or-later
#
# This script checks vmlinux to ensure that all functions can call ftrace_caller() either directly,
# or through the stub, ftrace_tramp_text, at the end of kernel text.

# Error out if any command fails
set -e

# Allow for verbose output
if [ "$V" = "1" ]; then
	set -x
fi

if [ $# -lt 2 ]; then
	echo "$0 [path to nm] [path to vmlinux]" 1>&2
	exit 1
fi

# Have Kbuild supply the path to nm so we handle cross compilation.
nm="$1"
vmlinux="$2"

stext_addr=$($nm "$vmlinux" | grep -e " [TA] _stext$" | \
	cut -d' ' -f1 | tr '[:lower:]' '[:upper:]')
ftrace_caller_addr=$($nm "$vmlinux" | grep -e " T ftrace_caller$" | \
	cut -d' ' -f1 | tr '[:lower:]' '[:upper:]')
ftrace_tramp_addr=$($nm "$vmlinux" | grep -e " T ftrace_tramp_text$" | \
	cut -d' ' -f1 | tr '[:lower:]' '[:upper:]')

ftrace_caller_offset=$(echo "ibase=16;$ftrace_caller_addr - $stext_addr" | bc)
ftrace_tramp_offset=$(echo "ibase=16;$ftrace_tramp_addr - $ftrace_caller_addr" | bc)
sz_32m=$(printf "%d" 0x2000000)
sz_64m=$(printf "%d" 0x4000000)

# ftrace_caller - _stext < 32M
if [ "$ftrace_caller_offset" -ge "$sz_32m" ]; then
	echo "ERROR: ftrace_caller (0x$ftrace_caller_addr) is beyond 32MiB of _stext" 1>&2
	echo "ERROR: consider disabling CONFIG_FUNCTION_TRACER, or reducing the size \
		of kernel text" 1>&2
	exit 1
fi

# ftrace_tramp_text - ftrace_caller < 64M
if [ "$ftrace_tramp_offset" -ge "$sz_64m" ]; then
	echo "ERROR: kernel text extends beyond 64MiB from ftrace_caller" 1>&2
	echo "ERROR: consider disabling CONFIG_FUNCTION_TRACER, or reducing the size \
		of kernel text" 1>&2
	exit 1
fi